#Name	: Num2Words - To expand a number into equivalent words
#Param	: any number column or string column with numeric value

def Num2Words(p_num):
    def Parse(xxnum):
        xstr='_'
        if(xxnum[0:1]>'0'):
            xstr=xstr + uniq[xxnum[0:1]]+'#Hundred#'
        if(xxnum[1:]>'00'):
            if(xxnum[1:2]>'0'):
                if(xxnum[1:2]>'1'):
                    xstr=xstr + tens[xxnum[1:2]]
                    if(xxnum[2:]>'0'):
                        xstr=xstr + '#' + uniq[xxnum[2:]]
                else:
                    xstr=xstr + '#' + uniq[xxnum[1:]]
            else:
                xstr=xstr + '#' + uniq[xxnum[2:]]
        return xstr

    uniq={}
    uniq['1']='One'
    uniq['2']='Two'
    uniq['3']='Three'
    uniq['4']='Four'
    uniq['5']='Five'
    uniq['6']='Six'
    uniq['7']='Seven'
    uniq['8']='Eight'
    uniq['9']='Nine'
    uniq['10']='Ten'
    uniq['11']='Eleven'
    uniq['12']='Twelve'
    uniq['13']='Thirteen'
    uniq['14']='Fourteen'
    uniq['15']='Fifteen'
    uniq['16']='Sixteen'
    uniq['17']='Seventeen'
    uniq['18']='Eighteen'
    uniq['19']='Nineteen'
    
    tens={}
    tens['2']='Twenty'
    tens['3']='Thirty'
    tens['4']='Forty'
    tens['5']='Fifty'
    tens['6']='Sixty'
    tens['7']='Seventy'
    tens['8']='Eighty'
    tens['9']='Ninety'
    
    # convert parameter to string, if not string
    if type(p_num)!='str':
        xnum_str=str(p_num)+'.00'
    else:
        xnum_str=p_num+'.00'
    
    # split amount into parts
    parts=xnum_str.split('.')
    
    # main part
    xnum=parts[0].rjust(15,'0')

    xret='_'
    if xnum[0:3]>'000':
        xtril=Parse(xnum[0:3])
        xret=xret + xtril[1:] + '#Trillion#'
    if xnum[3:6]>'000':
        xbil=Parse(xnum[3:6])
        xret=xret + xbil[1:] + '#Billion#'
    if xnum[6:9]>'000':
        xmil=Parse(xnum[6:9])
        xret=xret + xmil[1:] + '#Million#'
    if xnum[9:12]>'000':
        xthou=Parse(xnum[9:12])
        xret=xret + xthou[1:] + '#Thousand#'
    if xnum[12:]>'000':
        xrest=Parse(xnum[12:])
        xret=xret + xrest[1:]
    # decimal part
    xcents='0'+parts[1].ljust(2,'0')
    if xcents>'000':
        xdec=Parse(xcents)
        xret=xret + '#.#' + xdec[1:]
    return (' '.join(x.strip() for x in xret[1:].split('#'))).strip()
